/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.CortesiaDireccionDAO;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.CortesiaDireccion;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.service.CortesiaDireccionService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Shiro
 */
@Service("cortesiaDireccionService")
public class CortesiaDireccionServiceImpl implements CortesiaDireccionService {

    @Autowired
    private CortesiaDireccionDAO cortesiaDireccionDAO;

    public List<CortesiaDireccion> obtenerTodos() {
        return cortesiaDireccionDAO.obtenerTodos();
    }

    public CortesiaDireccion obtenerID(Integer id) {
        return cortesiaDireccionDAO.obtenerID(id);
    }

    @Transactional
    public CortesiaDireccion suscribir(CortesiaDireccion entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return cortesiaDireccionDAO.suscribir(entidad);

    }

    @Transactional
    public CortesiaDireccion actualizacion(CortesiaDireccion entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return cortesiaDireccionDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(CortesiaDireccion entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        cortesiaDireccionDAO.actualizacion(entidad);
    }

    public List<CortesiaDireccion> pesquisar(Marca marca, ClaseServicio claseServicio, Date fecInicio, Date fecFinal) {

        return cortesiaDireccionDAO.pesquisar(marca, claseServicio, fecInicio, fecFinal);
    }

    public List<CortesiaDireccion> buscar(CortesiaDireccion cortesiaDireccion) {
        return cortesiaDireccionDAO.buscar(cortesiaDireccion);
    }

    public List<CortesiaDireccion> buscarFolio(CortesiaDireccion cortesiaDireccion) {
        return cortesiaDireccionDAO.buscarFolio(cortesiaDireccion);
    }
}
